<template>
	<v-card class="tableCard" flat>
		<v-card-title>
			<v-text-field
				v-model="search"
				append-icon="mdi-magnify"
				label="Search stratifications..."
				single-line
				hide-details
			/>
		</v-card-title>

		<v-data-table
			class="stratificationsTable"
			:headers="headers"
			:items="tableData"
			:loading="isLoading"
			:search="search"
			:page.sync="page"
			:sort-by.sync="sortBy"
			:sort-desc.sync="sortDesc"
			multi-sort
			loading-text="Loading stratifications..."
			:no-data-text="hasError ? 'There was an error loading stratifications. Please refresh.' : 'No stratifications'"
		>
			<template v-slot:item.isDemo="{ item }">
				<v-simple-checkbox v-model="item.isDemo" disabled></v-simple-checkbox>
			</template>
			<template slot="item.submittedAt" slot-scope="props">
				{{ new Date(props.item.submittedAt).toLocaleString() }}
			</template>
			<template slot="item.actions" slot-scope="props">
				<stratification-delete-button :stratification="getStratificationFromTableRow(props.item)" color="error" small />
			</template>
		</v-data-table>
	</v-card>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from '@vue/composition-api';
import { DataTableHeader } from 'vuetify';
import { Stratification } from '@/store/types';
import StratificationDeleteButton from './StratificationDeleteButton.vue';

interface StratificationsTableRow extends Pick<Stratification, 'id'> {
	fieldId: string;
	fieldName?: string;
	groupName: string;
	submittedAt: string;
}

export default defineComponent({
	components: { StratificationDeleteButton },
	props: {
		isLoading: {
			type: Boolean,
		},
		isLoaded: {
			type: Boolean,
		},
		hasError: {
			type: Boolean,
		},
		stratifications: {
			type: Array as () => Stratification[],
			default: [],
		},
	},
	setup(props, { root }) {
		const search = ref<string>('');
		const page = ref<number>(1);
		const sortBy = ref<string[]>(['submittedAt']);
		const sortDesc = ref<boolean[]>([true]);
		const headers: DataTableHeader[] = [
			{ text: 'ID', value: 'id' },
			{ text: 'Field ID', value: 'fieldId' },
			{ text: 'Field name', value: 'fieldName' },
			{ text: 'Group', value: 'groupName' },
			{ text: 'Submitted date', value: 'submittedAt' },
			{ text: 'Demo', value: 'isDemo' },
			{ text: '', value: 'actions', sortable: false },
		];

		const tableData = computed<StratificationsTableRow[]>(() =>
			props.stratifications.map(({ id, featureOfInterest: fieldId, dateCreated, meta, isDemo }) => {
				const field = root.$store.getters['resources/getFieldById'](fieldId);
				const groupName = root.$store.getters['groups/getGroupNameById'](meta.groupId) || 'no group';

				return {
					id,
					fieldId,
					fieldName: field?.name,
					groupName,
					isDemo,
					submittedAt: dateCreated,
				};
			})
		);

		const getStratificationFromTableRow = (row: StratificationsTableRow) =>
			props.stratifications.find((stratification) => stratification.id === row.id);

		watch(search, () => (page.value = 1));

		return {
			search,
			page,
			sortBy,
			sortDesc,
			headers,
			tableData,
			getStratificationFromTableRow,
		};
	},
});
</script>

<style lang="scss">
.stratificationsTable.v-data-table table > tbody > tr {
	td:nth-last-child(2) {
		width: 160px;
		font-size: 0.75rem;
	}

	td:nth-child(2) {
		word-break: break-all;
	}

	td:last-child {
		width: 80px;
	}
}
</style>
